package jp.co.ois.hoge.sandbox;

import java.util.List;

import javax.validation.Valid;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.ui.Model;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

@Controller
@RequestMapping("/hoge")
public class HogeController {
	private static final Log log = LogFactory.getLog(HogeController.class);

	@Autowired
	HogeLogic logic;

	@ModelAttribute("hogeForm")
	public HogeForm createForm() {
		return new HogeForm();
	}

	@RequestMapping({"/", "/index"})
	@Transactional(readOnly=true)
	public String index(Model model) {
		log.debug("called.");
		List<HogeForm> list = logic.list();
		model.addAttribute("list", list);
		return "hoge";
	}

	@RequestMapping("/update")
	@Transactional(rollbackFor=Throwable.class)
	public String update(@Valid HogeForm form, BindingResult result, Model model) {
		log.debug("called.");
		if (result.hasErrors()) {
	        model.addAttribute("result", "error");
			return index(model);
		}
		logic.update(form);
        model.addAttribute("result", "success");
		return index(model);
	}

	@RequestMapping("/select")
	@Transactional(readOnly=true)
	public String select(@RequestParam int id, Model model) {
		log.debug("called.");
		HogeForm form = logic.select(id);
		model.addAttribute(form);
		return index(model);
	}
}
